<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑代码仓库' : '添加代码仓库'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="名称" name="title">
        <a-input
          allow-clear
          placeholder="xxx-admin"
          v-model:value="form.title"
        />
      </a-form-item>
      <a-form-item label="地址" name="domain">
        <a-input
          allow-clear
          placeholder="http://git.gxwebsoft.com/website/web.git"
          v-model:value="form.domain"
        />
      </a-form-item>
      <a-form-item label="厂商" name="brand">
        <a-select
          optionFilterProp="label"
          :options="GitBrands"
          :value="form.brand"
          @change="changeGitBrand"
        />
      </a-form-item>
      <a-form-item label="排序" name="sortNumber">
        <a-input-number
          :min="0"
          :max="9999"
          class="ele-fluid"
          placeholder="请输入排序号"
          v-model:value="form.sortNumber"
        />
      </a-form-item>
      <a-form-item label="描述" name="comments">
        <a-textarea
          :rows="4"
          :maxlength="200"
          placeholder="请输入描述"
          v-model:value="form.comments"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addCompanyGit, updateCompanyGit } from '@/api/system/companyGit';
  import { CompanyGit } from '@/api/system/companyGit/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import {DictData} from "@/api/system/dict-data/model";
  import {listDictData} from "@/api/system/dict-data";

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: CompanyGit | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);
  const GitBrands = ref<DictData[]>([]);

  // 用户信息
  const form = reactive<CompanyGit>({
    id: undefined,
    title: undefined,
    brand: undefined,
    icon: undefined,
    language: undefined,
    companyId: undefined,
    domain: undefined,
    account: undefined,
    password: undefined,
    comments: undefined,
    createTime: undefined,
    tenantId: undefined,
    status: 0,
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    name: [
      {
        required: true,
        type: 'string',
        message: '请填写代码仓库名称',
        trigger: 'blur'
      }
    ],
    gitUrl: [
      {
        required: true,
        type: 'string',
        message: '请填写代码仓库名称',
        trigger: 'blur'
      }
    ]
  });

  const changeGitBrand = (value: string, item: DictData) => {
    form.brand = item.label;
    form.icon = item.dictDataCode;
  }

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateCompanyGit : addCompanyGit;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      listDictData({dictCode:'GitBrand'}).then((data)=>{
        GitBrands.value = data;
      })
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
